# Code coverage report for ol/source/tilevectorsource.js

## Statements: 59.02% (72 / 122) Branches: 47.22% (17 / 36) Functions: 35.71% (5 / 14) Lines: 59.02% (72 / 122) Ignored: none

All files » ol/source/ » tilevectorsource.js

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    3551

    1
    1
    1
    1
    1
    1
    1
    1
    1

    1

    4

    4

    4

    4

    4

    4

    4

    4
    1
    3

    3

    1

    1

    1

    1

    1

    1

    1

    1

    1

    1

    1

    1

    1

    1

    11
    11
    11
    8

    11

    1
    4

    1

    1
    1
    1
    1
    1
    1
    1

    1

    1
    2
    4
    4
    4
    4
    4

    4

    4
    4
    4
    4

    4

    4

    1

    1
    1
    1

    1

    1

     goog.provide('ol.source.TileVector');

    goog.require('goog.array');
    goog.require('goog.asserts');
    goog.require('goog.object');
    goog.require('ol.TileUrlFunction');
    goog.require('ol.featureloader');
    goog.require('ol.source.State');
    goog.require('ol.source.Vector');
    goog.require('ol.tilecoord');
    goog.require('ol.tilegrid.TileGrid');

    /**
     * @classdesc
     * A vector source in one of the supported formats, where the data is divided
     * into tiles in a fixed grid pattern.
     *
     * @constructor
     * @extends {ol.source.Vector}
     * @param {olx.source.TileVectorOptions} options Options.
     * @api
     */
    ol.source.TileVector = function(options) {

      goog.base(this, {
        attributions: options.attributions,
        logo: options.logo,
        projection: undefined,
        state: ol.source.State.READY,
        wrapX: options.wrapX
      });

      /**
       * @private
       * @type {ol.format.Feature|undefined}
       */
      this.format_ = goog.isDef(options.format) ? options.format : null;

      /**
       * @private
       * @type {ol.tilegrid.TileGrid}
       */
      this.tileGrid_ = options.tileGrid;

      /**
       * @private
       * @type {ol.TileUrlFunctionType}
       */
      this.tileUrlFunction_ = ol.TileUrlFunction.nullTileUrlFunction;

      /**
       * @private
       * @type {?ol.TileVectorLoadFunctionType}
       */
      this.tileLoadFunction_ = goog.isDef(options.tileLoadFunction) ?
          options.tileLoadFunction : null;

      goog.asserts.assert(!goog.isNull(this.format_) ||
          !goog.isNull(this.tileLoadFunction_),
          'Either format or tileLoadFunction are required');

      /**
       * @private
       * @type {Object.<string, Array.<ol.Feature>>}
       */
      this.tiles_ = {};

      if (goog.isDef(options.tileUrlFunction)) {
        this.setTileUrlFunction(options.tileUrlFunction);
      } else Iif (goog.isDef(options.urls)) {
        this.setUrls(options.urls);
      } else Iif (goog.isDef(options.url)) {
        this.setUrl(options.url);
      }

    };
    goog.inherits(ol.source.TileVector, ol.source.Vector);

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.addFeature = goog.abstractMethod;

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.addFeatures = goog.abstractMethod;

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.clear = function() {
      goog.object.clear(this.tiles_);
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.forEachFeature = goog.abstractMethod;

    /**
     * Iterate through all features whose geometries contain the provided
     * coordinate at the provided resolution, calling the callback with each
     * feature. If the callback returns a "truthy" value, iteration will stop and
     * the function will return the same value.
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {number} resolution Resolution.
     * @param {function(this: T, ol.Feature): S} callback Called with each feature
     *     whose goemetry contains the provided coordinate.
     * @param {T=} opt_this The object to use as `this` in the callback.
     * @return {S|undefined} The return value from the last call to the callback.
     * @template T,S
     */
    ol.source.TileVector.prototype.forEachFeatureAtCoordinateAndResolution =
        function(coordinate, resolution, callback, opt_this) {

      var tileGrid = this.tileGrid_;
      var tiles = this.tiles_;
      var tileCoord = tileGrid.getTileCoordForCoordAndResolution(coordinate,
          resolution);

      var tileKey = this.getTileKeyZXY_(tileCoord[0], tileCoord[1], tileCoord[2]);
      var features = tiles[tileKey];
      if (goog.isDef(features)) {
        var i, ii;
        for (i = 0, ii = features.length; i < ii; ++i) {
          var feature = features[i];
          var geometry = feature.getGeometry();
          goog.asserts.assert(goog.isDefAndNotNull(geometry),
              'feature geometry is defined and not null');
          if (geometry.containsCoordinate(coordinate)) {
            var result = callback.call(opt_this, feature);
            if (result) {
              return result;
            }
          }
        }
      }
      return undefined;
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.forEachFeatureInExtent = goog.abstractMethod;

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.forEachFeatureInExtentAtResolution =
        function(extent, resolution, f, opt_this) {
      var tileGrid = this.tileGrid_;
      var tiles = this.tiles_;
      var z = tileGrid.getZForResolution(resolution);
      var tileRange = tileGrid.getTileRangeForExtentAndZ(extent, z);
      var x, y;
      for (x = tileRange.minX; x <= tileRange.maxX; ++x) {
        for (y = tileRange.minY; y <= tileRange.maxY; ++y) {
          var tileKey = this.getTileKeyZXY_(z, x, y);
          var features = tiles[tileKey];
          if (goog.isDef(features)) {
            var i, ii;
            for (i = 0, ii = features.length; i < ii; ++i) {
              var result = f.call(opt_this, features[i]);
              if (result) {
                return result;
              }
            }
          }
        }
      }
      return undefined;
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.getClosestFeatureToCoordinate =
        goog.abstractMethod;

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.getExtent = goog.abstractMethod;

    /**
     * Return the features of the TileVector source.
     * @inheritDoc
     * @api
     */
    ol.source.TileVector.prototype.getFeatures = function() {
      var tiles = this.tiles_;
      var features = [];
      var tileKey;
      for (tileKey in tiles) {
        goog.array.extend(features, tiles[tileKey]);
      }
      return features;
    };

    /**
     * Get all features whose geometry intersects the provided coordinate for the
     * provided resolution.
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {number} resolution Resolution.
     * @return {Array.<ol.Feature>} Features.
     * @api
     */
    ol.source.TileVector.prototype.getFeaturesAtCoordinateAndResolution =
        function(coordinate, resolution) {
      var features = [];
      this.forEachFeatureAtCoordinateAndResolution(coordinate, resolution,
          /**
           * @param {ol.Feature} feature Feature.
           */
          function(feature) {
            features.push(feature);
          });
      return features;
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.getFeaturesInExtent = goog.abstractMethod;

    /**
     * Handles x-axis wrapping and returns a tile coordinate transformed from the
     * internal tile scheme to the tile grid's tile scheme. When the tile coordinate
     * is outside the resolution and extent range of the tile grid, `null` will be
     * returned.
     * @param {ol.TileCoord} tileCoord Tile coordinate.
     * @param {ol.proj.Projection} projection Projection.
     * @return {ol.TileCoord} Tile coordinate to be passed to the tileUrlFunction or
     *     null if no tile URL should be created for the passed `tileCoord`.
     */
    ol.source.TileVector.prototype.getTileCoordForTileUrlFunction =
        function(tileCoord, projection) {
      var tileGrid = this.tileGrid_;
      goog.asserts.assert(!goog.isNull(tileGrid), 'tile grid needed');
      if (this.getWrapX() && projection.isGlobal()) {
        tileCoord = ol.tilecoord.wrapX(tileCoord, tileGrid, projection);
      }
      return ol.tilecoord.withinExtentAndZ(tileCoord, tileGrid) ?
          tileCoord : null;
    };

    /**
     * @param {number} z Z.
     * @param {number} x X.
     * @param {number} y Y.
     * @private
     * @return {string} Tile key.
     */
    ol.source.TileVector.prototype.getTileKeyZXY_ = function(z, x, y) {
      return z + '/' + x + '/' + y;
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.loadFeatures =
        function(extent, resolution, projection) {
      var tileGrid = this.tileGrid_;
      var tileUrlFunction = this.tileUrlFunction_;
      var tiles = this.tiles_;
      var z = tileGrid.getZForResolution(resolution);
      var tileRange = tileGrid.getTileRangeForExtentAndZ(extent, z);
      var tileCoord = [z, 0, 0];
      var x, y;
      /**
       * @param {string} tileKey Tile key.
       * @param {Array.<ol.Feature>} features Features.
       * @this {ol.source.TileVector}
       */
      function success(tileKey, features) {
        tiles[tileKey] = features;
        this.changed();
      }
      for (x = tileRange.minX; x <= tileRange.maxX; ++x) {
        for (y = tileRange.minY; y <= tileRange.maxY; ++y) {
          var tileKey = this.getTileKeyZXY_(z, x, y);
          Eif (!(tileKey in tiles)) {
            tileCoord[1] = x;
            tileCoord[2] = y;
            var urlTileCoord = this.getTileCoordForTileUrlFunction(
                tileCoord, projection);
            var url = goog.isNull(urlTileCoord) ? undefined :
                tileUrlFunction(urlTileCoord, 1, projection);
            Eif (goog.isDef(url)) {
              tiles[tileKey] = [];
              var tileSuccess = goog.partial(success, tileKey);
              Iif (!goog.isNull(this.tileLoadFunction_)) {
                this.tileLoadFunction_(url, goog.bind(tileSuccess, this));
              } else {
                var loader = ol.featureloader.loadFeaturesXhr(url,
                    /** @type {ol.format.Feature} */ (this.format_), tileSuccess);
                loader.call(this, extent, resolution, projection);
              }
            }
          }
        }
      }
    };

    /**
     * @inheritDoc
     */
    ol.source.TileVector.prototype.removeFeature = goog.abstractMethod;

    /**
     * @param {ol.TileUrlFunctionType} tileUrlFunction Tile URL function.
     */
    ol.source.TileVector.prototype.setTileUrlFunction = function(tileUrlFunction) {
      this.tileUrlFunction_ = tileUrlFunction;
      this.changed();
    };

    /**
     * @param {string} url URL.
     */
    ol.source.TileVector.prototype.setUrl = function(url) {
      this.setTileUrlFunction(ol.TileUrlFunction.createFromTemplates(
          ol.TileUrlFunction.expandUrl(url)));
    };

    /**
     * @param {Array.<string>} urls URLs.
     */
    ol.source.TileVector.prototype.setUrls = function(urls) {
      this.setTileUrlFunction(ol.TileUrlFunction.createFromTemplates(urls));
    };